.container {
	/* agregamos una posicion relativa a nuestro elemento container,
	esto con el fin de agregar a sus hijos como elementos con posicion absoluta y ambos queden al mismo nivel */
	position: relative;
	margin: 150px auto;
	border: 1px solid black;
	width: 200px;
	height: 200px;

	/* así como tenemos una función perspective, tenemos un atributo perspective que se aplica al elemento padre
	la ventaja que tiene esque aplica esta perspectiva a todos sus hijos descendientes, a diferencia de si lo usamos
	como funcion, donde cada elemento donde se aplique tiene su propia perspectiva */
    perspective: 1500px;
	/* podemos cambiar el origen de la perspectiva, esto dicho de otro modo nos indicaría desde donde estamos viendo el objeto
	por defecto es center, podemos asignar right y eso indicaría que el elemento al que estamos aplicando la perspectiva
	lo estamos viendo desde el lado derecho */
    /* perspective-origin: right; */
	/* podemos asignar un valor en pixeles y esto sería como verlo desde el centro 500px hacía la derecha y si 
	asignamos un valor negativo, sería como moverlo del centro 500 pixeles hacia la izquierda */
	/* si solo enviamos un valor de perspectiva por ejemplo en este caso X, el segundo valor será centrado por defecto y no tomará el mismo
	valor para ambas, por lo que aqui nuestra perspectiva está 500px en el eje x y centrado en el eje y */
    perspective-origin: 500px;
	/* perspective-origin: center; */

	/* en css existe otra cosa a tomar en cuenta al momento de aplicar transformaciones
	a elementos contenedores o padres, y esque los hijos tambien se van a transformar en base a esas transformaciones
	pero si no tenemos cuidado podemos tener resultados no esperados */
	/* por ejemplo si rotamos nuestro elemento padre aunnque a nuestros elementos hijos les hayamos aplicado
	una transformacion diferente, si al padre por ejemplo lo rotamos 90grados sobre un eje, va a desaparecer junto con sus hijos
	y esto es porque por defecto los elementos padre al sufrir transformaciones, aplanan el espacio 3d de sus elementos hijos y recordemos 
	ademas que los elementos en html no tienen profundidad, por lo que verlo de un angulo de 90 grados hará que el elemento desaparezca,
	
	aunque tengamos la perspectiva aplicada en el contenedor y los elementos hijos con transformaciones que nos permitieran por 
	ejemplo ver los elementos cuando estamos viendo el contenedor padre rotado 90 grados, no los vamos a ver, porque los elementos fueron aplanados
	y estan al mismo nivel del contenedor */
	/* transform: rotateY(90deg); */
	transform: rotateY(130deg);
	/* el valor flat del atributo transform-style es el valor por defecto, es decir que nuestro contenedor 
	//sobre si mismo crea otro espacio 3d donde sus elementos comparten el mismo plano*/
	/* transform-style: flat; */
	/* para que nuestros elementos mantengan su espacio 3d sin ser afectado por su padre
	debemos usar el atributo transform-style con valor de preserve-3d, de este modo los hijos del contenedor
	cada uno mantiene su espacio 3d separado, y se crea otro para el elemento padre, que a su vez contiene a los hijos dentro de sí mismo */
	transform-style: preserve-3d;
}

.box1 {
	/* agregamos este elemento con posición absoluta para que quede al mismo nivel que box2 que también
	será absoluto */
	position: absolute;
	background: red;
	width: 100%;
	height: 100%;
	/* un elemento se puede rotar no solo en el eje z que es el que se usa al momento de que usamos
    el método rotate(), sino tambien en sus ejes X y Y, los ejes x y y aplican la rotación tridimensional al
    elemento; los ejes x y y son los ejes del propio elemento el eje x se refiere a una linea imaginaria vertical que atraviesa el elemento
    de arriba a abajo, sobre el cual gira el elemento, y el eje y es lo mismo pero a nivel horizontal, sobre estos 
    ejes gira el elemento*/
	/* cabe denotar que podemos usar rotateX y rotateY para hacer estas rotaciones que igual como
    la rotación en el eje Z, se hacen usando grados */
	/* transform: rotateX(40deg); */
	/* transform: rotateX(100deg); */
	/* transform: rotateX(100deg) rotateY(30deg); */
	/* podemos asignar la perspectiva a nuestro elemento usando el metodo perspective dentro de nuestro
	transform, el valor que recibe es una medida, entre más cercana a 0 sea, significa que estamos más cerca del plano del elemento
	al que estamos aplicando la perspectiva
	por lo que la transformación que se aplique será más visible solamente entre más lejos estemos del elemento, la perspectiva
	se puede cambiar usando perspective-origin, y por defecto inicia en el centro del elemento, es decir ese valor de perspectiva si no se 
	asigna un origen diferente, hace referencia a la distancia que hay al centro del elemento */
	/* transform: perspective(100px) rotateX(0) rotateY(40deg); */
	/* con la perspectiva, nos es mas facil ver el efecto 3d que tienen las transformaciones que se aplican, sobretodo podemos
	ver a más detalle como trabaja el eje Z */
    /* transform: rotateX(30deg) rotateY(80deg) rotateZ(30deg); */
	/* vamos a rotar este elemento solo en el eje Y para que sea más fácil de ver*/
	transform: rotateY(80deg);

	/* el contenido que esté dentro de un elemento que tiene una transformación tambien se verá afectado, es decir
    dentro de este div tenemos texto, el texto rotará de la misma forma que su contenedor */

	/* este codigo solo es para darle estilo al texto dentro del box */
	color: white;
	font-family: sans-serif;
	text-align: center;
	/* z-index se debe usar con cuidado pues puede traer resultados no esperados, si se usa en combinación con un translate
	en un plano tridimensional como pasa aquí donde no se ven los efectos del z-index */
	/* z-index: 1; */

	/* existe en css otro atributo que podemos usar en ciertos casos, si por ejemplo
	queremos que la parte trasera de un elemento no esté visible, podemos usar backface-visibility con
	valor de hidden, esto lo que hará es que cuando el elemento esté completamente volteado con algun transform por
	ejemplo, al momento de que debería mostrarse la parte trasera del elemento, esta no se mostrará, es decir
	el elemento desaparecerá y solo podremos ver la parte delantera, el valor por defecto es visible
	así que en la mayoría de los casos solo deberiamos usar el atributo cuando queremos ocultar la parte
	trasera del mismo */
	/* backface-visibility: visible; */
	backface-visibility: hidden;
	
}

/* a nuestra segunda caja le asignamos un fondo azul con la posición absoluta para que
se coloca de forma absoluta sobre nuestro contenedor que es relativo*/
.box2 {
	position: absolute;
	background: blue;
	width: 100%;
	height: 100%;

	/* transform: rotateY(80deg); */
	/* transform: translateX(1rem) translateZ(10rem); */
	/* transform: translateX(1rem) translateZ(-10rem); */
	/* vamos a aplicar un transform a  nuestro elemento, vamos a trasladarlo sobre el eje Z
	el eje Z si tenemos la perspectiva de forma centrada que es el comportamiento por defecto, solo veremos
	al elemento hacerse mas grande y pequeño porque el valor por defecto de la perspectiva es centrado, en cambio
	si comenzamos a jugar con esa perspectiva, podemos ver desde distintos angulos el objeto y al trasladarlo sobre el eje Z 
	hacia adelante y hacia atrás podemos ver de mejor manera como se mueve sobre el eje, acercandose y alejandose
	de nosotros, ademas si lo vemos de lado, de acuerdo a nuestra perspectiva
	 veremos que pareciera tambien estarse trasladando, pero en realidad es un efecto
	dado por la perspectiva que tenemos */
	/* vamos a reducir la cantidad de translate para que el elemento no se separe tanto de nuestro objeto principal, esto debido a que
	se saldria de la parte visible de nuestro navegador debido a la rotación que le agregamos al contenedor */
	transform: translateX(1rem) translateZ(-10rem);

	color: white;
	font-family: sans-serif;
	text-align: center;
	/* z-index: -200; */
}